/***************************************************************************

  P        R        O        J        E        C        T

                      ۰          
  ۰    ۰    ۰ ۰  ۰    ۰         ۰
     ۰    ۰  ۰۰  ۰    ۰  
  ۰  ۰    ۰۰۰  ۰     ۰  ۰
  ۰     ۰ ۰  ۰   ۰          
                                 

	A JAM Australia program with the goal of developing a competitive 3d
   environment for total immersion gaming. Based on _extremely_ simplified
   ray-casting alogorithms, using no real casting at all, based on simple
   trigonomotery and algebraic rules of similarity for speedy renderings.

   All code contained herein is Copyright (c) 1995 Josh McDonald

   21/08/95:	Project Alpha-3d begun. Floor casting almost working.

   22/08/95:    Floor and roof casting now works. Slowly.

*****************************************************************************/

// Coding notes

// 1920 degrees for easiest calculations. Uses pre-generated fixed-point
// for sinus values.

// Wall idea was sprouted by somebody else, but his docco was a pile of crap,
// so he deserves no credit (only a teeeeeny influence anywaze)

// Similar triangles method of floor tracing ripped from Gardens of
// Imagination. But my code is better :)

// Map/Texture coordinates 0-63. Fine coodirnates 0-4095

// Errrrr..... Ummm...... Better get on wit it, eh?

#include <math.h>
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <process.h>
#include <conio.h>
#include <dos.h>
#include <alloc.h>

#define num_maps 4
//Number of texture maps

#define debug YEAHMATEDEBUGISONSOTHEREBYTHEWAYKARENISPISSINGMEOFFTODAYSOIMCUT
//#define beep sound(300);delay(300);nosound();
#define beep

//Needs variables, eh?

unsigned int viewer_height=100;	//Height of viewer
unsigned int viewer_distance=128;  //Viewer distance from screen
unsigned int viewer_x=2048;  //X position (viewer starts in centre of map)
unsigned int viewer_y=2048;  //Y position
unsigned int viewer_angle=320;	//Viewing angle
long far sine[1920]; //Sine values
long far cosine[1920]; //Shit, what might this be?
unsigned char far *floormap; //4k map 64x64 res
unsigned char far *roofmap; //roof map :)
unsigned char far *texturemap[(num_maps-1)]; //2 texture maps
unsigned int f_active=0; //Current function (used for error trapping)

//Hows about some function defs?
#ifdef debug
	int main(void); //Only define main if debugging mode
#endif
void error(char *error); //Used to exit with error
void startup_alpha3d (void); //Startup aplha-3d project
void close_alpha3d (void); //Close aplha-3d project
void draw_maze (void); //Draw thy maze
long sinef(int angle);
long cosinef(int angle);

long sinef (int angle)
{
	if(angle<0) angle=1920-(abs(angle));
	if(angle>1920) angle%=1920;
	return sine[angle];
}

long cosinef (int angle)
{
	if(angle<0) angle=1920-abs(angle);
	if(angle>1920) angle%=1920;
	return cosine[angle];
}

//Now, CODE!!!!
#ifdef debug
	int main(void)
	{
		while(kbhit()) getch();
		startup_alpha3d();
		int k=0;
		while(k!=27)
		{
			_fmemset(MK_FP(0x0a000,0),0,64000);
			draw_maze();
			k=getch();
			viewer_x=rand()%4096;
			viewer_y=rand()%4096;
			viewer_angle=rand()%1920;
		}
		close_alpha3d();
		return 0;
	}
#endif

void error(char *error)
{
	_AX=0x3;
	asm int 0x10;
	textcolor(4);
	cprintf("Alpha-3d error! \r\n---------------\n\r\n%s",error);
	cout << " In function " << f_active;
	sound(200);
	delay(200);
	nosound();
	exit(1);
}

void startup_alpha3d(void)
{
	_AX=19;      	//Go to mode 13h
	asm int 0x10;
	f_active=1;
	floormap=(char far *)farmalloc(4096);
	roofmap=(char far *)farmalloc(4096);
	for (int i=0;i<num_maps;i++)
	{
		texturemap[i]=(char far *)farmalloc(4096);
	}
	if(texturemap[num_maps-1]==NULL)
		error("Out of memory");
	float _2pi=2*(22/7); //Close enough 4 now :)
	float add=_2pi/1920; //Devide by degrees
	float radians=0.0;   //Current radians count
	for (i=0;i<=1920;i++) //One more just 2 be safe.....
	{
		sine[i]=(sin(radians)*32768);	//Get fixed point value
		cosine[i]=(cos(radians)*32768); //Again
		radians+=add;			//Progress 2 next degree
	}

	//Next bits are just pre-generated maps for original testing
	//version

	FILE *input=fopen("marbpale.pal","rb");
	outportb(0x3c8,0);
	for (i=0;i<768;i++)
	{
		outportb(0x3c9,getc(input));
	}
	fclose(input);
	input=fopen("marbpale.pix","rb");
	for (i=0;i<4096;i++)
	{
		texturemap[0][i]=getc(input);
	}
	fclose(input);
	input=fopen("other.pix","rb");
	for (i=0;i<4096;i++)
	{
		texturemap[1][i]=getc(input);
	}
	fclose(input);
	input=fopen("roof.pix","rb");
	for (i=0;i<4096;i++)
	{
		texturemap[2][i]=getc(input);
	}
	fclose(input);
	input=fopen("dent.pix","rb");
	for (i=0;i<4096;i++)
	{
		texturemap[3][i]=getc(input);
	}
	fclose(input);
	for (i=0;i<4096;i++)
	{
		floormap[i]=0;
		roofmap[i]=2;
	}
	for (int y=0;y<64;y+=2)
	{
		for (int x=0;x<64;x+=2)
		{
			floormap[y*64+x]=1;
			roofmap[y*64+x]=3;
		}
	}
	for (y=1;y<64;y+=2)
	{
		for (int x=1;x<64;x+=2)
		{
			floormap[y*64+x]=1;
			roofmap[y*64+x]=3;
		}
	}
	//That should do it, eh?
	return;
}

void close_alpha3d(void)
{
	_AX=3;
	asm int 0x10;
	farfree(floormap);
	for(int i=0;i<num_maps;i++)
		farfree(texturemap[i]);
	farfree(roofmap);
	cout << "Wow, man, like alpha-3d didn't hang my PC!!!\n\n";
	return;
}

void plot(int x, int y, int c)	//Slooooooow plotpixel with clipping
{
//	if(x&&x<320&&y&&y<200)
	pokeb(0x0a000,y*320+x,c);
	return;
}

int count=0;

void draw_maze (void)
{
	f_active=2;
	beep
	long temp_x;	//Temporary variable for fixed-point mult
	long temp_y;
	int distancea[100]; //Distance into texture map (fine coords)
	int distance;
	int position; //Pixel position (fine coords)
	int map_x,map_y; //Map block
	int tex_x,tex_y; //Texture pixel
	char pixel_colour=4; //Actual pixel to be plotted
	int x=0; //Current x position of texturemapping
	int y;
	int column_angle;
	float A,a,c,C;
	int dist_count=0;

	//Pre-generate distance table
	for(y=199;y>105;y--)
	{
		a=viewer_distance;
		c=100-y;
		C=viewer_height;
		A=a/c * C;
		distancea[dist_count]=A;
		dist_count++;
	}

	for(column_angle=viewer_angle-159;column_angle<viewer_angle+160;
		column_angle++)
	{
	dist_count=0;
		for(y=199;y>105;y--) //Step up line
		{
		distance=distancea[dist_count];
		if(distance>1500) continue;
		dist_count++;
		/*	a=viewer_distance;
			c=100-y;
			C=viewer_height;
			A=a/c * C;
			distance=A;*/

			 //Calc distance into map
			temp_x=-distance*(sinef(column_angle));
			temp_y=distance*(cosinef(column_angle));
			temp_x>>=15;	//Goto int
			temp_y>>=15;	//""
			temp_x+=viewer_x;
			temp_y+=viewer_y;
			//Now that we have pixel's fine coord position
			//Get position in map
			if(temp_y<0||temp_x<0)
				continue;
			map_x=temp_x/64;
			tex_x=temp_x%64;
			map_y=temp_y/64;
			tex_y=temp_y%64;

			if(map_y<0||map_y>63||map_x<0||map_x>63)
				continue;

			int map_off=map_y*64+map_x;
			int tex_off=tex_y*64+tex_x;

			pixel_colour=texturemap[floormap[map_off]]
				[tex_off]; //Get colour

			plot(x,y,pixel_colour); //Draw it!!!!

			pixel_colour=texturemap[roofmap[map_off]]
				[tex_off]; //Get colour

			plot(x,199-y,pixel_colour); //Draw Matching roof pixel!

		}
		x++; //Increment column
		beep
	}
	return;
}
